package immibis.ccperiphs.rfid;

import immibis.ccperiphs.RenderUtils;

import org.lwjgl.opengl.GL11;

import net.minecraft.src.TileEntity;
import net.minecraft.src.TileEntitySpecialRenderer;
import net.minecraft.src.forge.MinecraftForgeClient;

public class RenderTileRFIDWriter extends TileEntitySpecialRenderer {

	@Override
	public void renderTileEntityAt(TileEntity teRaw, double x, double y, double z, float partialTick) {
		immibis.core.RenderUtils.setBrightness(teRaw.worldObj, teRaw.xCoord, teRaw.yCoord, teRaw.zCoord);
		
		GL11.glPushMatrix();
		GL11.glTranslated(x, y, z);
		
		TileRFIDWriter te = (TileRFIDWriter)teRaw;
		
		MinecraftForgeClient.bindTexture("/immibis/ccperiphs/world.png");
		GL11.glDisable(GL11.GL_CULL_FACE);
		GL11.glDisable(GL11.GL_LIGHTING);
		
		float interpLid = te.lidClosedAmt + TileRFIDWriter.LID_RATE * partialTick * (te.state == TileRFIDWriter.STATE_RUN ? 1 : -1);
		interpLid = Math.min(Math.max(interpLid, 0), 1);
		
		RenderUtils.renderRFIDWriterDynamic(te.facing, interpLid, te.visualProgress, te.state != TileRFIDWriter.STATE_EMPTY, te.state == TileRFIDWriter.STATE_RUN, te.heldCardColour);
		GL11.glEnable(GL11.GL_CULL_FACE);
		MinecraftForgeClient.unbindTexture();
		
		GL11.glPopMatrix();
	}

}
