package immibis.ccperiphs.rfid;

import org.lwjgl.opengl.GL11;

import net.minecraft.src.GuiContainer;
import net.minecraft.src.ItemStack;

public class GuiRFIDWriter extends GuiContainer {
	private ContainerRFIDWriter cont;
	public GuiRFIDWriter(ContainerRFIDWriter c) {
		super(c);
		cont = c;
		xSize = 186;
		ySize = 147;
	}

	@Override
	protected void drawGuiContainerBackgroundLayer(float var1, int var2, int var3) {
		int k = mc.renderEngine.getTexture("/immibis/ccperiphs/rfid/writer.png");
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        mc.renderEngine.bindTexture(k);
        int l = (width - xSize) / 2;
        int i1 = (height - ySize) / 2;
        drawTexturedModalRect(l, i1, 0, 0, xSize, ySize);
        
        double scaledProgress = 0;
        ItemStack stack = cont.getSlot(0).getStack();
        if(stack != null && stack.stackTagCompound != null && stack.stackTagCompound.hasKey("data"))
        	scaledProgress = 1;
        else if(cont.tile.progress > 0)
        	scaledProgress = 1 - ((double)cont.tile.progress / TileRFIDWriter.TICKS_TO_WRITE);
        
        drawTexturedModalRect(l + 13, i1 + 46, 13, 152, (int)(160 * scaledProgress), 8);
	}
}
